'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.moleculeDropdownListSizes = undefined;

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _from = require('babel-runtime/core-js/array/from');

var _from2 = _interopRequireDefault(_from);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BASE_CLASS = 'sui-MoleculeDropdownList';
var CLASS_HIDDEN = 'is-hidden';

var SIZES = {
  SMALL: 'small',
  MEDIUM: 'medium',
  LARGE: 'large'
};

var MoleculeDropdownList = function (_Component) {
  (0, _inherits3.default)(MoleculeDropdownList, _Component);

  function MoleculeDropdownList() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, MoleculeDropdownList);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = MoleculeDropdownList.__proto__ || (0, _getPrototypeOf2.default)(MoleculeDropdownList)).call.apply(_ref, [this].concat(args))), _this), _this.refDropdownList = _react2.default.createRef(), _this.getFocusedOptionIndex = function (options) {
      var currentElementFocused = document.activeElement;
      return (0, _from2.default)(options).reduce(function (focusedOptionIndex, option, index) {
        if (option === currentElementFocused) focusedOptionIndex = index;
        return focusedOptionIndex;
      }, 0);
    }, _this.handleKeyDown = function (_ref2) {
      var key = _ref2.key;
      var _this2 = _this,
          getFocusedOptionIndex = _this2.getFocusedOptionIndex,
          refDropdownList = _this2.refDropdownList;

      var options = refDropdownList.current.children;
      var numOptions = options.length;
      if (key === 'ArrowDown' || key === 'ArrowUp') {
        var index = getFocusedOptionIndex(options);
        if (index >= 0 || index <= numOptions) {
          if (key === 'ArrowDown' && index < numOptions - 1) options[index + 1].focus();
          if (key === 'ArrowUp' && index > 0) options[index - 1].focus();
        }
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(MoleculeDropdownList, [{
    key: 'render',
    value: function render() {
      var refDropdownList = this.refDropdownList,
          handleKeyDown = this.handleKeyDown,
          classNames = this.classNames,
          extendedChildren = this.extendedChildren;


      return _react2.default.createElement(
        'div',
        {
          ref: refDropdownList,
          tabIndex: '0',
          onKeyDown: handleKeyDown,
          className: classNames
        },
        extendedChildren
      );
    }
  }, {
    key: 'extendedChildren',
    get: function get() {
      var _props = this.props,
          children = _props.children,
          value = _props.value,
          size = _props.size,
          visible = _props.visible,
          onSelect = _props.onSelect,
          props = (0, _objectWithoutProperties3.default)(_props, ['children', 'value', 'size', 'visible', 'onSelect']);

      return _react2.default.Children.toArray(children).filter(Boolean).map(function (child, index) {
        var valueChild = child.props.value;

        var selected = Array.isArray(value) ? value.includes(valueChild) : value === valueChild;
        return _react2.default.cloneElement(child, (0, _extends3.default)({}, props, {
          index: index,
          onSelect: onSelect,
          selected: selected
        }));
      });
    }
  }, {
    key: 'classNames',
    get: function get() {
      var _props2 = this.props,
          size = _props2.size,
          visible = _props2.visible;

      return (0, _classnames2.default)(BASE_CLASS, BASE_CLASS + '--' + size, (0, _defineProperty3.default)({}, CLASS_HIDDEN, !visible));
    }
  }]);
  return MoleculeDropdownList;
}(_react.Component);

MoleculeDropdownList.displayName = 'MoleculeDropdownList';

MoleculeDropdownList.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  /** Content to be included in the list (MoleculeDropdownOption) */
  children: _propTypes2.default.node,

  /** Visible or not */
  visible: _propTypes2.default.bool,

  /** selected value */
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.array]),

  /** size (height) of the list */
  size: _propTypes2.default.oneOf((0, _values2.default)(SIZES)),

  /** callback on select option */
  onSelect: _propTypes2.default.func
} : {} : {};

MoleculeDropdownList.defaultProps = {
  size: SIZES.SMALL,
  onSelect: function onSelect() {}
};

exports.default = MoleculeDropdownList;
exports.moleculeDropdownListSizes = SIZES;